//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_client.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "bot_client.h"
#include "bot_communicate.h"
#include "bot_weapons.h"
#include "engine.h"
#include "waypoint.h"
#include "logging.h"
#include "scripting.h"

// instant damage (from cbase.h)
#define DMG_CRUSH			(1 << 0)	// crushed by falling or moving object
#define DMG_BURN			(1 << 3)	// heat burned
#define DMG_FREEZE			(1 << 4)	// frozen
#define DMG_FALL			(1 << 5)	// fell too far
#define DMG_SHOCK			(1 << 8)	// electric shock
#define DMG_DROWN			(1 << 14)	// Drowning
#define DMG_NERVEGAS		(1 << 16)	// nerve toxins, very bad
#define DMG_RADIATION		(1 << 18)	// radiation exposure
#define DMG_DROWNRECOVER	(1 << 19)	// drowning recovery
#define DMG_ACID			(1 << 20)	// toxic chemicals or acid burns
#define DMG_SLOWBURN		(1 << 21)	// in an oven
#define DMG_SLOWFREEZE		(1 << 22)	// in a subzero freezer


// types of damage to ignore...
#define IGNORE_DAMAGE (DMG_CRUSH | DMG_FREEZE | DMG_SHOCK | DMG_DROWN | \
                       DMG_NERVEGAS | DMG_RADIATION | DMG_DROWNRECOVER | \
                       DMG_ACID | DMG_SLOWBURN | DMG_SLOWFREEZE)

extern int mod_id;
extern bot_t bots[32];
extern int current_type;
extern tf_team_data tf_data[4];

extern int text_state;

bot_weapon_t weapon_defs[MAX_WEAPONS]; // array of weapon definitions


// This message is sent when the TFC VGUI menu is displayed.
void BotClient_TFC_VGUI(void *p, int bot_index)
{
   if ((*(int *)p) == 2)  // is it a team select menu?

      bots[bot_index].start_action = MSG_TFC_TEAM_SELECT;

   else if ((*(int *)p) == 3)  // is is a class selection menu?

      bots[bot_index].start_action = MSG_TFC_CLASS_SELECT;
}


// This message is sent when the Counter-Strike VGUI menu is displayed.
void BotClient_CS_VGUI(void *p, int bot_index)
{
   if ((*(int *)p) == 2)  // is it a team select menu?

      bots[bot_index].start_action = MSG_CS_TEAM_SELECT;

   else if ((*(int *)p) == 26)  // is is a terrorist model select menu?

      bots[bot_index].start_action = MSG_CS_T_SELECT;

   else if ((*(int *)p) == 27)  // is is a counter-terrorist model select menu?

      bots[bot_index].start_action = MSG_CS_CT_SELECT;
}


// This message is sent when a menu is being displayed in Counter-Strike.
void BotClient_CS_ShowMenu(void *p, int bot_index)
{
   static int state = 0;   // current state machine state

   if (state < 3)
   {
      state++;  // ignore first 3 fields of message
      return;
   }

   if (strcmp((char *)p, "#Team_Select") == 0)  // team select menu?
   {
      bots[bot_index].start_action = MSG_CS_TEAM_SELECT;
   }
   else if (strcmp((char *)p, "#Terrorist_Select") == 0)  // T model select?
   {
      bots[bot_index].start_action = MSG_CS_T_SELECT;
   }
   else if (strcmp((char *)p, "#CT_Select") == 0)  // CT model select menu?
   {
      bots[bot_index].start_action = MSG_CS_CT_SELECT;
   }

   state = 0;  // reset state machine
}


// This message is sent when a client joins the game.  All of the weapons
// are sent with the weapon ID and information about what ammo is used.
void BotClient_Valve_WeaponList(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static bot_weapon_t bot_weapon;
   bot_t * pBot = NULL;

   if (state == 0)
   {
      state++;
      strcpy(bot_weapon.szClassname, (char *)p);
   }
   else if (state == 1)
   {
      state++;
      bot_weapon.iAmmo1 = *(int *)p;  // ammo index 1
   }
   else if (state == 2)
   {
      state++;
      bot_weapon.iAmmo1Max = *(int *)p;  // max ammo1
   }
   else if (state == 3)
   {
      state++;
      bot_weapon.iAmmo2 = *(int *)p;  // ammo index 2
   }
   else if (state == 4)
   {
      state++;
      bot_weapon.iAmmo2Max = *(int *)p;  // max ammo2
   }
   else if (state == 5)
   {
      state++;
      bot_weapon.iSlot = *(int *)p;  // slot for this weapon
   }
   else if (state == 6)
   {
      state++;
      bot_weapon.iPosition = *(int *)p;  // position in slot
   }
   else if (state == 7)
   {
      state++;
      bot_weapon.iId = *(int *)p;  // weapon ID
   }
   else if (state == 8)
   {
	   bot_weapon.iFlags = *(int *)p;  // flags for weapon (WTF???)

      // store away this weapon with it's ammo information...
      weapon_defs[bot_weapon.iId] = bot_weapon;
	  pBot = &(bots[bot_index]);

	  if (bots[bot_index].weapons[bot_weapon.iId])
	  {
		  delete bots[bot_index].weapons[bot_weapon.iId];
	  }
	  if (mod_id == FLF_DLL)
	  {
		  if (bot_weapon.iId == FLF_WEAPON_KNIFE)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotMelee(bot_weapon, pBot);
		  } 
		  else if (bot_weapon.iId == FLF_WEAPON_BERETTA ||  bot_weapon.iId == FLF_WEAPON_MK23)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotPistol(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_SPAS12 || bot_weapon.iId == FLF_WEAPON_RS202M2)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotShotgun(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_HK21)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotHK21(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_MSG90 || bot_weapon.iId == FLF_WEAPON_SAKO)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotRifle(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_AK5 || bot_weapon.iId == FLF_WEAPON_M4 || bot_weapon.iId == FLF_WEAPON_FAMAS)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotAssault(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_MP5A2 || bot_weapon.iId == FLF_WEAPON_MP5SD || bot_weapon.iId == FLF_WEAPON_UMP45 ||  bot_weapon.iId == FLF_WEAPON_MAC10)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotSMG(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == FLF_WEAPON_FLASHBANG || bot_weapon.iId == FLF_WEAPON_HEGRENADE)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotGrenade(bot_weapon, pBot);
		  }
		  else
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotWeapon(bot_weapon, pBot);
		  }
	  }
	  else if (mod_id == TFC_DLL)
	  {
		  if (bot_weapon.iId == TF_WEAPON_MEDIKIT || bot_weapon.iId == TF_WEAPON_AXE || bot_weapon.iId == TF_WEAPON_KNIFE || bot_weapon.iId == TF_WEAPON_SPANNER)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotMelee(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_SNIPERRIFLE)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotSniperRifle(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_AUTORIFLE)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotAutoRifle(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_SHOTGUN || bot_weapon.iId == TF_WEAPON_SUPERSHOTGUN)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotShotgun(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_NAILGUN || bot_weapon.iId == TF_WEAPON_SUPERNAILGUN)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotNailgun(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_GL)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotGLauncher(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_RPG || bot_weapon.iId == TF_WEAPON_IC)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotRocket(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_FLAMETHROWER)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotFlameThrower(bot_weapon,  pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_AC)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotAutoCannon(bot_weapon, pBot);
		  }
		  else if (bot_weapon.iId == TF_WEAPON_TRANQ || bot_weapon.iId == TF_WEAPON_RAILGUN)
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotPistol(bot_weapon, pBot);
		  }
		  else
		  {
			  bots[bot_index].weapons[bot_weapon.iId] = new CBotWeapon(bot_weapon, pBot);
		  }

	  }
	  else
	  {
		  bots[bot_index].weapons[bot_weapon.iId] = new CBotWeapon(bot_weapon, pBot);
	  }


#if 0
	FILE *fp = fopen("bot.txt", "a");
	fprintf(fp, "\nClassname = %s \n", bot_weapon.szClassname);
	fprintf(fp, "ammo1 = %d \n", bot_weapon.iAmmo1);
	fprintf(fp, "maxammo1 = %d\n", bot_weapon.iAmmo1Max);
	fprintf(fp, "ammo2 = %d\n", bot_weapon.iAmmo2);
	fprintf(fp, "maxammo2 = %d\n", bot_weapon.iAmmo2Max);
	fprintf(fp, "slot = %d\n", bot_weapon.iSlot);
	fprintf(fp, "position = %d\n", bot_weapon.iPosition);
	fprintf(fp, "ID = %d\n", bot_weapon.iId);
	fprintf(fp, "flags = %d\n", bot_weapon.iFlags);
	fclose(fp);
#endif

      state = 0;
   }
}

void BotClient_TFC_WeaponList(void *p, int bot_index)
{
   // this is just like the Valve Weapon List message
   BotClient_Valve_WeaponList(p, bot_index);
}

void BotClient_CS_WeaponList(void *p, int bot_index)
{
   // this is just like the Valve Weapon List message
   BotClient_Valve_WeaponList(p, bot_index);
}

void BotClient_Gearbox_WeaponList(void *p, int bot_index)
{
   // this is just like the Valve Weapon List message
   BotClient_Valve_WeaponList(p, bot_index);
}


// This message is sent when a weapon is selected (either by the bot chosing
// a weapon or by the server auto assigning the bot a weapon).
void BotClient_Valve_CurrentWeapon(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int iState;
   static int iId;
   static int iClip;

   if (state == 0)
   {
      state++;
      iState = *(int *)p;  // state of the current weapon (WTF???)
   }
   else if (state == 1)
   {
      state++;
      iId = *(int *)p;  // weapon ID of current weapon
   }
   else if (state == 2)
   {
	  state = 0;
	  CBotWeapon *weapon;
      if (iId <= 31 && iId > 0)
      {
		 iClip = *(int *)p;  // ammo currently in the clip for this weapon
         bots[bot_index].bot_weapons |= (1<<iId);  // set this weapon bit
		 weapon = bots[bot_index].weapons[iId];

		 weapon->iClip = iClip;
		 if (weapon->iAmmo1Index > 0)
			weapon->iAmmo1Amt = bots[bot_index].m_rgAmmo[weapon->iAmmo1Index];
		 if (weapon->iAmmo2Index > 0)
			weapon->iAmmo2Amt = bots[bot_index].m_rgAmmo[weapon->iAmmo2Index];
         //bots[bot_index].weapons[iId]->iAmmo1Amt = bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo1];
         //bots[bot_index].weapons[iId]->iAmmo2Amt = bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo2];

		 if (iState == 0)
		 {
			 return;
		 }


         bots[bot_index].current_weapon.iId = iId;
         bots[bot_index].current_weapon.iClip = iClip;

         // update the ammo counts for this weapon...
         bots[bot_index].current_weapon.iAmmo1 =
            bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo1];
         bots[bot_index].current_weapon.iAmmo2 =
            bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo2];
      }


   }
}

void BotClient_TFC_CurrentWeapon(void *p, int bot_index)
{
   // this is just like the Valve Current Weapon message
   BotClient_Valve_CurrentWeapon(p, bot_index);
}

void BotClient_CS_CurrentWeapon(void *p, int bot_index)
{
   // this is just like the Valve Current Weapon message
   BotClient_Valve_CurrentWeapon(p, bot_index);
}

void BotClient_Gearbox_CurrentWeapon(void *p, int bot_index)
{
   // this is just like the Valve Current Weapon message
   BotClient_Valve_CurrentWeapon(p, bot_index);
}


// This message is sent whenever ammo ammounts are adjusted (up or down).
void BotClient_Valve_AmmoX(void *p, int bot_index)
{
	static int state = 0;   // current state machine state
    static int index;
    static int ammount;
    int ammo_index;
	int weapon_index;

    if (state == 0)
    {
       state++;
       index = *(int *)p;  // ammo index (for type of ammo)
    }
    else if (state == 1)
    {
	    ammount = *(int *)p;  // the ammount of ammo currently available
	    bots[bot_index].m_rgAmmo[index] = ammount;  // store it away
	    state = 0;

		ammo_index = bots[bot_index].current_weapon.iId;	   
	    // update the ammo counts for this weapon...
	    bots[bot_index].current_weapon.iAmmo1 =
		    bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo1];
	    bots[bot_index].current_weapon.iAmmo2 =
		    bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo2];

		for (weapon_index = 0; weapon_index < 32; weapon_index++)
		{
			if (bots[bot_index].weapons[weapon_index]->iAmmo1Index == index)
			{
				bots[bot_index].weapons[weapon_index]->iAmmo1Amt = bots[bot_index].m_rgAmmo[index];
			}
			if (bots[bot_index].weapons[weapon_index]->iAmmo2Index == index)
			//if (ammo_index >= 0)
			{
				bots[bot_index].weapons[weapon_index]->iAmmo2Amt = bots[bot_index].m_rgAmmo[index];
			}
		}

	}
}

void BotClient_TFC_AmmoX(void *p, int bot_index)
{
   // this is just like the Valve AmmoX message
   BotClient_Valve_AmmoX(p, bot_index);
}

void BotClient_CS_AmmoX(void *p, int bot_index)
{
   // this is just like the Valve AmmoX message
   BotClient_Valve_AmmoX(p, bot_index);
}

void BotClient_Gearbox_AmmoX(void *p, int bot_index)
{
   // this is just like the Valve AmmoX message
   BotClient_Valve_AmmoX(p, bot_index);
}


// This message is sent when the bot picks up some ammo (AmmoX messages are
// also sent so this message is probably not really necessary except it
// allows the HUD to draw pictures of ammo that have been picked up.  The
// bots don't really need pictures since they don't have any eyes anyway.
void BotClient_Valve_AmmoPickup(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int index;
   static int ammount;
   int ammo_index;

   if (state == 0)
   {
      state++;
      index = *(int *)p;
   }
   else if (state == 1)
   {
      ammount = *(int *)p;

      bots[bot_index].m_rgAmmo[index] = ammount;

      ammo_index = bots[bot_index].current_weapon.iId;

      // update the ammo counts for this weapon...
      bots[bot_index].current_weapon.iAmmo1 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo1];
      bots[bot_index].current_weapon.iAmmo2 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo2];

      state = 0;
   }
}

void BotClient_TFC_AmmoPickup(void *p, int bot_index)
{
   // this is just like the Valve Ammo Pickup message
   BotClient_Valve_AmmoPickup(p, bot_index);
}

void BotClient_CS_AmmoPickup(void *p, int bot_index)
{
   // this is just like the Valve Ammo Pickup message
   BotClient_Valve_AmmoPickup(p, bot_index);
}

void BotClient_Gearbox_AmmoPickup(void *p, int bot_index)
{
   // this is just like the Valve Ammo Pickup message
   BotClient_Valve_AmmoPickup(p, bot_index);
}


// This message gets sent when the bot picks up a weapon.
void BotClient_Valve_WeaponPickup(void *p, int bot_index)
{
   int index;

   index = *(int *)p;

   // set this weapon bit to indicate that we are carrying this weapon
   bots[bot_index].bot_weapons |= (1<<index);
}

void BotClient_TFC_WeaponPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_WeaponPickup(p, bot_index);
}

void BotClient_CS_WeaponPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_WeaponPickup(p, bot_index);
}

void BotClient_Gearbox_WeaponPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_WeaponPickup(p, bot_index);
}


// This message gets sent when the bot picks up an item (like a battery
// or a healthkit)
void BotClient_Valve_ItemPickup(void *p, int bot_index)
{
}

void BotClient_TFC_ItemPickup(void *p, int bot_index)
{
   // this is just like the Valve Item Pickup message
   BotClient_Valve_ItemPickup(p, bot_index);
}

void BotClient_CS_ItemPickup(void *p, int bot_index)
{
   // this is just like the Valve Item Pickup message
   BotClient_Valve_ItemPickup(p, bot_index);
}

void BotClient_Gearbox_ItemPickup(void *p, int bot_index)
{
   // this is just like the Valve Item Pickup message
   BotClient_Valve_ItemPickup(p, bot_index);
}


// This message gets sent when the bots health changes.
void BotClient_Valve_Health(void *p, int bot_index)
{
   bots[bot_index].bot_health = *(int *)p;  // health ammount
}

void BotClient_TFC_Health(void *p, int bot_index)
{
   // this is just like the Valve Health message
   BotClient_Valve_Health(p, bot_index);
}

void BotClient_CS_Health(void *p, int bot_index)
{
   // this is just like the Valve Health message
   BotClient_Valve_Health(p, bot_index);
}

void BotClient_Gearbox_Health(void *p, int bot_index)
{
   // this is just like the Valve Health message
   BotClient_Valve_Health(p, bot_index);
}


// This message gets sent when the bots armor changes.
void BotClient_Valve_Battery(void *p, int bot_index)
{
   bots[bot_index].bot_armor = *(int *)p;  // armor ammount
}

void BotClient_TFC_Battery(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Battery(p, bot_index);
}

void BotClient_CS_Battery(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Battery(p, bot_index);
}

void BotClient_Gearbox_Battery(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Battery(p, bot_index);
}


// This message gets sent when the bots are getting damaged.
void BotClient_Valve_Damage(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int damage_armor;
   static int damage_taken;
   static int damage_bits;  // type of damage being done
   static Vector damage_origin;

   if (state == 0)
   {
      state++;
      damage_armor = *(int *)p;
   }
   else if (state == 1)
   {
      state++;
      damage_taken = *(int *)p;
   }
   else if (state == 2)
   {
      state++;
      damage_bits = *(int *)p;
   }
   else if (state == 3)
   {
      state++;
      damage_origin.x = *(float *)p;
   }
   else if (state == 4)
   {
      state++;
      damage_origin.y = *(float *)p;
   }
   else if (state == 5)
   {
	  state = 0;
      damage_origin.z = *(float *)p;

      if ((damage_armor > 0) || (damage_taken > 0))
      {
         // ignore certain types of damage...
         if (damage_bits & IGNORE_DAMAGE)
            return;

		 if (bots[bot_index].pEdict->v.origin == damage_origin)
			 return;

         // if the bot doesn't have an enemy and someone is shooting at it then
         // turn in the attacker's direction...
         if (bots[bot_index].pBotEnemy == NULL)
         {
            // face the attacker...
            Vector v_enemy = damage_origin - bots[bot_index].pEdict->v.origin;
            Vector bot_angles = UTIL_VecToAngles( v_enemy );

            bots[bot_index].pEdict->v.ideal_yaw = bot_angles.y;

            BotFixIdealYaw(bots[bot_index].pEdict);
         }
      }

   }
}

void BotClient_TFC_Damage(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Damage(p, bot_index);
}

void BotClient_CS_Damage(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Damage(p, bot_index);
}

void BotClient_Gearbox_Damage(void *p, int bot_index)
{
   // this is just like the Valve Battery message
   BotClient_Valve_Damage(p, bot_index);
}


// This message gets sent when the bots money ammount changes (for CS)
void BotClient_CS_Money(void *p, int bot_index)
{
   static int state = 0;   // current state machine state

   if (state == 0)
   {
      state++;

      bots[bot_index].bot_money = *(int *)p;  // amount of money
   }
   else
   {
      state = 0;  // ingore this field
   }
}

void BotClient_TFC_StatusIcon(void *p, int bot_index) {
	static int state = 0;
	static bool on;
	static int num = 0;
	//FILE *fp = fopen("bot.txt", "a"); fprintf(fp,"State: %d, type: %d \n", state, current_type); fclose(fp);
	if (state == 0) {
		state++;
		if (*(int *)p == 1) {
			on = TRUE;
		} else {
			on = FALSE;
		}
	} else if (state == 1) {
		state++;
		if (current_type == TYPE_STRING) {
			if (strncmp("flag_", (char *)p, 5) == 0) {
				//fp= fopen("bot.txt" ,"a"); fprintf(fp,"\t Setting got flag to: %d\n", on); fclose(fp);
				bots[bot_index].gotFlag = on;
				bots[bot_index].destination = -1;
			}
			if (on == FALSE) {state = 0; num = 1;} else num = 4;
			if (strncmp("dmg_", (char *)p, 4) == 0) {num = 4; state =2;}
		} else {
			if (current_type != TYPE_CHAR) {
				//fp= fopen("bot.txt" ,"a"); fprintf(fp,"It's not a char!!!!, its a %d \n", current_type); fclose(fp);
			}
			num = 6;
		}
	} else if (state == num) {
		state = 0;
		num = 4;
	} else {
		state++;
	}
}

void BotClient_TFC_PlaySound(void *p, int bot_index) {
	if (bots[bot_index].bot_class == TFC_CLASS_CIVILIAN) {
		if (strcmp("spk \"!HTD_DOORS\"\n", (char*)p) == 0) {
			//FILE *fp = fopen("bot.txt", "a"); fprintf(fp, "The doors are open.\n"); fclose(fp);
			bots[bot_index].state = STATE_DOORS_OPEN;
			bots[bot_index].stateTime = gpGlobals->time + 30.0;
			bots[bot_index].destination = -1;
		}
	}
}

#define WORDLEN 40

void BotClient_TFC_SayText(void *p, int bot_index)
{
	static int state = 0;
	static bool go = FALSE;
	int wordLen = WORDLEN;
	char firstWord[WORDLEN];
	char secondWord[WORDLEN];
	char thirdWord[WORDLEN];
	int i;
	char *current = (char *)p;
	if (state == 0) 
	{
		if (*(int *)p >= 1) 
		{
			go = TRUE;
		}
		else
		{
			go = FALSE;
		}
		state++;
		return;
	}
	state =0;
	if (!go) return;
	go = FALSE;

	current++; //skip the first character
	i = 0;
	if (strncmp("(TEAM) ", current, 7) == 0) {
		current += 7;
	}
	while (current && *current != ':' && *current != '\0' && i <wordLen) 
	{
		firstWord[i] = *current;
		current++;
		i++;
	}
	if (*current == '\0' || *current == '\n') return; // nothing here
	if (i == wordLen) return; // too long
	firstWord[i] = '\0'; // terminate
	if (*current == ':') current++;
	if (*current == '\0' || *current == '\n') return;
	if (*current == ' ') current++;

	i = 0;
	while (current && *current != ' ' && *current != '\0' && *current != '\n' && i <wordLen)
	{
		secondWord[i] = *current;
		current++;
		i++;
	}
	if (*current == '\0' || *current == '\n') return; // nothing here
	if (i == wordLen) return; // too long
	secondWord[i] = '\0'; // terminate
	if (*current == ' ') current++;

	i = 0;
	while (current && *current != ' ' && *current != '\0' && *current != '\n' && i <wordLen)
	{
		thirdWord[i] = *current;
		current++;
		i++;
	}
	if (i == wordLen) return; // too long
	thirdWord[i] = '\0'; // terminate
	//fp = fopen("bot.txt", "a"); fprintf(fp, "First Word: %s\nSecond Word: %s\nThird Word: %s\n", firstWord, secondWord, thirdWord); fclose(fp);
	if (stricmp(secondWord, STRING(bots[bot_index].pEdict->v.netname)) != 0) 
	{
		//fp = fopen("bot.txt", "a"); fprintf(fp, "The second word is not my name.\n"); fclose(fp);
		return;
	}
	for (i = 1; i <= gpGlobals->maxClients; i++) 
	{
		edict_t *pPlayer = INDEXENT(i);
		if (pPlayer == NULL) continue;
		if (stricmp(firstWord, STRING(pPlayer->v.netname)) == 0)
		{
			int bot_team = UTIL_GetTeam(bots[bot_index].pEdict);
			int player_team = UTIL_GetTeam(pPlayer);
			if (bot_team == player_team || (tf_data[bot_team].allies & (1<<player_team))) {
				if (strcmp(thirdWord, "guard")==0) 
				{
					//fp = fopen("botlog.txt", "a"); fprintf(fp, "I have been ordered to guard.\n"); fclose(fp);
					bots[bot_index].behaviour = BEHAVE_GUARD;
					bots[bot_index].currentPoint = -1;
					bots[bot_index].destination = -1;
					bots[bot_index].commander = pPlayer;
					BotSayText(bots+bot_index, "guarding", 1.0, TRUE, FALSE);
					return;
				} else if (strcmp(thirdWord, "attack") == 0) {
					//fp = fopen("botlog.txt", "a"); fprintf(fp, "I have been ordered to attack.\n"); fclose(fp);
					bots[bot_index].behaviour = BEHAVE_ATTACK;
					bots[bot_index].currentPoint = -1;
					bots[bot_index].destination = -1;
					bots[bot_index].commander = pPlayer;
					BotSayText(bots+bot_index, "attacking", 1.0, TRUE, FALSE);
					return;
				} else if (strcmp(thirdWord, "follow") == 0) {
					//fp = fopen("botlog.txt", "a"); fprintf(fp, "I have been ordered to follow.\n"); fclose(fp);
					bots[bot_index].behaviour = BEHAVE_FOLLOW;
					bots[bot_index].currentPoint = -1;
					bots[bot_index].destination = -1;
					bots[bot_index].commander = pPlayer;
					BotSayText(bots+bot_index, "following", 1.0, TRUE, FALSE);
					return;
				} else if (strcmp(thirdWord, "normal") == 0) {
					//fp = fopen("botlog.txt", "a"); fprintf(fp, "I have been ordered to return to normal.\n"); fclose(fp);
					bots[bot_index].behaviour = BEHAVE_NONE;
					bots[bot_index].currentPoint = -1;
					bots[bot_index].destination = -1;
					bots[bot_index].commander = NULL;
					BotSayText(bots+bot_index, "normal", 1.0, TRUE, FALSE);
					return;
				}
			} else {
				//fp = fopen("bot.txt", "a"); fprintf(fp, "We are not on the same team.\n"); fclose(fp);
				return;
			}
		}
	}
	return;
}

void BotClient_TFC_Grenades(void *p, int bot_index)
{
	static int state = 0;
	static int index = 0;
	if (state == 0) {
		state++;
		index = *(int *)p;
	} else if (state == 1) {
		if (index == 0 || index == 1) {
			bots[bot_index].tfc_grenades[index] = *(int *)p;
		}
		state = 0;
	}
}

void BotClient_SI_WeaponList(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_WeaponList(p, bot_index);
}

void BotClient_SI_CurrentWeapon(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_CurrentWeapon(p, bot_index);
}

void BotClient_SI_AmmoX(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_AmmoX(p, bot_index);
}

void BotClient_SI_AmmoPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_AmmoPickup(p, bot_index);
}

void BotClient_SI_WeaponPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_WeaponPickup(p, bot_index);
}

void BotClient_SI_ItemPickup(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_ItemPickup(p, bot_index);
}

void BotClient_SI_Health(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_Health(p, bot_index);
}

void BotClient_SI_Battery(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_Battery(p, bot_index);
}

void BotClient_SI_Damage(void *p, int bot_index)
{
   // this is just like the Valve Weapon Pickup message
   BotClient_Valve_Damage(p, bot_index);
}

void BotClient_SI_ShowMenu(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
	 //FILE *fp = fopen("bot.txt", "a"); fprintf(fp,"SI showmenu called.\n"); fclose(fp);
   if (state < 3)
   {
      state++;  // ignore first 3 fields of message
      return;
   }

   if (strcmp((char *)p, "#Menu_ChangeTeam") == 0)  // team select menu?
   {
      bots[bot_index].start_action = MSG_SI_TEAM_SELECT;
			//fp = fopen("bot.txt", "a"); fprintf(fp,"Setting the bot to team select.\n"); fclose(fp);
   }
	 else if (strcmp((char *)p, "#Menu_ChangeModel") == 0)
	 {
		  //fp = fopen("bot.txt", "a"); fprintf(fp,"Setting the bot to class select.\n"); fclose(fp);
	 	  bots[bot_index].start_action = MSG_SI_CLASS_SELECT;
	 } else if (strncmp("Please", (char *)p, 6) == 0) {
		 bots[bot_index].voting = 1;
	 }
   state = 0;  // reset state machine
}

void BotClient_SI_VoteState(void *p, int bot_index)
{
	//bots[bot_index].voting = *(int *)p;
}

void BotClient_SI_SciCarry(void *p, int bot_index)
{
	bots[bot_index].gotFlag = (*(int *)p > 0);
}

//*********** Front Line Force ownz
void BotClient_FLF_WeaponList(void *p, int bot_index)
{
	BotClient_Valve_WeaponList(p, bot_index);
}

void BotClient_FLF_ShowMenu(void *p, int bot_index)
{
	//dunno
}

void BotClient_FLF_CurrentWeapon(void *p, int bot_index)
{
	BotClient_Valve_CurrentWeapon(p, bot_index);
}

void BotClient_FLF_AmmoX(void *p, int bot_index)
{
	BotClient_Valve_AmmoX( p, bot_index);
}

void BotClient_FLF_WeaponPickup(void *p, int bot_index)
{
	BotClient_Valve_WeaponPickup(p,  bot_index);
}

void BotClient_FLF_AmmoPickup(void *p, int bot_index)
{
	BotClient_Valve_AmmoPickup(p,bot_index);
}

void BotClient_FLF_ItemPickup(void *p, int bot_index)
{
	BotClient_Valve_ItemPickup( p, bot_index);
}

void BotClient_FLF_Health(void *p, int bot_index)
{
	BotClient_Valve_Health(p, bot_index);
}

void BotClient_FLF_Battery(void *p, int bot_index)
{
	BotClient_Valve_Battery( p, bot_index);
}

void BotClient_FLF_Damage(void *p, int bot_index)
{
	BotClient_Valve_Damage(p, bot_index);
}

void BotClient_FLF_SayText(void *p, int bot_index)
{
	static int state =0;
	static char * text;
	int location=0;
	int unknown=0;
	//FILE *fp = fopen("bot.txt", "a"); fprintf(fp, "FLF say text called. state = %d \n."); fclose(fp);
	if (state == 0)
	{
		/*BotClient_TFC_SayText(p, bot_index);*/
		location = *(int *)p;
		state++;
	}
	else if (state == 1)
	{
		unknown = *(int *)p;
		state++;
	} 
	else if (state == 2)
	{
		//BotClient_TFC_SayText(p, bot_index);
		text = (char *)p;
		FLF_TextReceived(bots+bot_index, location, unknown, text);
		state = 0;
	}
}

void BotClient_FLF_VGUI(void *p, int bot_index)
{
	//FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "VGUI called: p = %d, bot_index = %d \n", *(int *)p, bot_index); fclose(fp);
	if (*(int *)p == 2) {
		bots[bot_index].start_action = MSG_FLF_TEAM_SELECT;
	} else if (*(int *)p == 3) {
		bots[bot_index].start_action = MSG_FLF_CLASS_SELECT;
	} else if (*(int *)p == 70) {
		bots[bot_index].start_action = MSG_FLF_WEAPON_CLASS_SELECT;
    //fp = fopen("botlog.txt", "a"); fprintf(fp, "Weapon class select\n"); fclose(fp);
  } else if (*(int *)p == 72) {
		bots[bot_index].start_action = MSG_FLF_SUB_SELECT;
	} else if (*(int *)p == 73) {
		bots[bot_index].start_action = MSG_FLF_SHOTGUN_SELECT;
	} else if (*(int *)p == 75) {
		bots[bot_index].start_action = MSG_FLF_RIFLE_SELECT;
	} else if (*(int *)p == 76) {
		bots[bot_index].start_action = MSG_FLF_PISTOL_SELECT;
	} else if (*(int *)p == 78) {
		bots[bot_index].start_action = MSG_FLF_HEAVY_SELECT;
	} else {
		//fp = fopen("botlog.txt", "a"); fprintf(fp, "Number ignored : %d \n", *(int *)p); fclose(fp);
	}
}

void BotClient_FLF_WarmUp(void *p, int bot_index) {
	if (*(int *)p == 1) {
		bots[bot_index].currentPoint = -1;
	} //new round so reset path
}

void BotClient_FLF_TextMessage(void *p, int bot_index) {
	static int state = 0;
	static int num = -1;
	if (state == 0) {
		state++;
		num = *(int *)p;
	} else {
		state = 0;
		if (num == 4) {
			if (strcmp("You are Defending\n", (char *)p) == 0) {
				//FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "We have a match for defending\n"); fclose(fp);
				bots[bot_index].flf_attacking = FALSE;
				bots[bot_index].pBotEnemy = NULL;
				bots[bot_index].state = STATE_NONE;
				bots[bot_index].stateTime = 0;
			} else if (strcmp("You are Attacking\n", (char *)p) == 0) {
				//FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "We have a match for attacking\n"); fclose(fp);
				bots[bot_index].flf_attacking = TRUE;
				bots[bot_index].pBotEnemy = NULL;
				bots[bot_index].state = STATE_NONE;
				bots[bot_index].stateTime = 0;
			}
		}
	}
}

void BotClient_FLF_ScreenFade(void *p, int bot_index) {
	static int state = 0;
	if (state == 0) {
		state++;
	}
	else if (state == 1)
	{
		float holdTime = (float) (*(unsigned short *)p)/1000;
		//FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "flashtime: %f   %d \n", holdTime, *(int *)p); fclose(fp);
		bots[bot_index].flashTime = gpGlobals->time + holdTime;
		state++;
	}
	else 
	{
		state++;
	}
	if (state == 7) state = 0;
}

void BotClient_FLF_SetFOV(void *p, int bot_index) {
	//FILE *fp=fopen("botweapon.txt", "a"); fprintf(fp,"setting fov to %d \n", *(int *)p); fclose(fp);
	//bots[bot_index].fov = *(int *)p;
	BotClient_Valve_SetFOV(p,bot_index);
}

void BotClient_TFC_TextMsg(void *p, int bot_index) {
	static int location = 0;
	if (text_state == 0) {
		location = *(int *)p;
	} else if (text_state == 1) {
		char * string = (char *)p;
/*
#ifdef _DEBUG
		FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "location: %d, text: %s\n", location, string); fclose(fp);
#endif
*/
		if (location == 4) {
			if (strcmp("#Build_noroom", string) == 0 || strcmp("#Build_notenoughmetal", string) == 0) {
				bots[bot_index].state = STATE_NONE;
				bots[bot_index].stateTime = 0;
			}
			else if (strcmp("#Sentry_destroyed", string) == 0) {
				bots[bot_index].pSentry = NULL;
			}
			else if (strcmp("#Dispenser_destroyed", string) == 0) {
				bots[bot_index].pDispenser = NULL;
			}
			else if (strcmp("#Dispenser_used", string) == 0)
			{
				bots[bot_index].f_detonate_dispenser_time = gpGlobals->time+1.0;
			}
		}
		else if (location == 1) 
		{
			MessageReceived(&(bots[bot_index]), string);
			if (strcmp("#Dispenser_finish", string) == 0) {
				edict_t* pSentry=NULL;
				int distance = 150;
				edict_t *pClosest = NULL;
				while (!FNullEnt (pSentry = UTIL_FindEntityInSphere(pSentry, bots[bot_index].pEdict->v.origin, 150) )) {
					if (strcmp(STRING(pSentry->v.classname), "building_dispenser") == 0) {
						float dist = (pSentry->v.origin - bots[bot_index].pEdict->v.origin).Length();
						if (dist < distance) {
							distance = dist;
							pClosest = pSentry;
						}
					}
				}
			}
		}
	}
	text_state++;
}

void BotClient_TFC_HudText(void *p, int bot_index)
{
	text_state++;
	if (text_state == 1)
	{
		MessageReceived(&(bots[bot_index]), (char *)p);
	}
}

void BotClient_TFC_BuildSt(void *p, int bot_index) {
	int choice = *(int *)p;
	if (choice == 4) {
		edict_t* pSentry=NULL;
		int distance = 150;
		edict_t *pClosest = NULL;
		while (!FNullEnt (pSentry = UTIL_FindEntityInSphere(pSentry, bots[bot_index].pEdict->v.origin, 150) )) {
			if (strcmp(STRING(pSentry->v.classname), "building_sentrygun") == 0) {
				float dist = (pSentry->v.origin - bots[bot_index].pEdict->v.origin).Length();
				if (dist < distance) {
					distance = dist;
					pClosest = pSentry;
				}
			}
		}
		if (pClosest == NULL) {
#ifdef _DEBUG
			FILE *fp = fopen("botlog.txt", "a");
			fprintf(fp, "Sentry pClosest is null!!\n");
			fclose(fp);
#endif
		} else {
			bots[bot_index].pSentry = pClosest;
#ifdef _DEBUG
			FILE *fp = fopen("botlog.txt", "a");
			fprintf(fp, "pSentry set to %x\n", pClosest);
			fclose(fp);
#endif
		}
	}
}

void BotClient_FLF_StatusMessage(void *p, int bot_index) {
	static int state = 0;
	static int arg5;
	if (state < 4) {
		state++;
	} else if (state == 4) {
		arg5 = *(int *)p;
		state++;
	} else if (state < ((arg5 == 2) ? 17 : 16)) {
		state++;
	} else {
		state = 0;
		char * string = (char *)p;
	  //FILE *fp = fopen("bot.txt", "a"); fprintf(fp, "The string is : %s\n", string); fclose(fp);
		if (strcmp("Can't Capture Right Now\n", string) == 0) {
			bots[bot_index].cantCaptureTime = gpGlobals->time + 2.0;
		}
	}
}

// This message gets sent when the bots get killed
void BotClient_Valve_DeathMsg(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int killer_index;
   static int victim_index;
   static edict_t *victim_edict;
   static int index;

   if (state == 0)
   {
      state++;
      killer_index = *(int *)p;  // ENTINDEX() of killer
   }
   else if (state == 1)
   {
      state++;
      victim_index = *(int *)p;  // ENTINDEX() of victim
   }
   else if (state == 2)
   {
      state = 0;
			char * method = (char*)p;

      victim_edict = INDEXENT(victim_index);
      index = victim_index - 1;

      // is this message about a bot being killed?
      if (index != -1)
      {
				 //LogBotDie(Waypoint_GetTeam(&(bots[index])), bots[index].last_point);
         if ((killer_index == 0) || (killer_index == victim_index))
         {
            // bot killed by world (worldspawn) or bot killed self...
            bots[index].pKiller = NULL;
         }
         else
         {
					 if (killer_index > 0) {
						 int bot_index = killer_index - 1;
						 if (bot_index > -1) {
							 if (FStrEq(method, "sentrygun") && victim_edict != NULL) {
								 //LogBotSentryKill(Waypoint_GetTeam(&bots[bot_index]), bots[bot_index].sentry_point);
							 } else {
								 //LogBotKill(Waypoint_GetTeam(&bots[bot_index]), bots[bot_index].last_point);
							 }
						 }
					 }
            // store edict of player that killed this bot...
            bots[index].pKiller = INDEXENT(killer_index);
         }
      }
   }
}

void BotClient_TFC_DeathMsg(void *p, int bot_index)
{
   // this is just like the Valve DeathMsg message
   BotClient_Valve_DeathMsg(p, bot_index);
}

void BotClient_CS_DeathMsg(void *p, int bot_index)
{
   // this is just like the Valve DeathMsg message
   BotClient_Valve_DeathMsg(p, bot_index);
}

void BotClient_SI_DeathMsg(void *p, int bot_index)
{
   // this is just like the Valve DeathMsg message
   BotClient_Valve_DeathMsg(p, bot_index);
}

void BotClient_Gearbox_DeathMsg(void *p, int bot_index)
{
   // this is just like the Valve DeathMsg message
   BotClient_Valve_DeathMsg(p, bot_index);
}

void BotClient_FLF_DeathMsg(void *p, int bot_index)
{
   // this is just like the Valve DeathMsg message
   BotClient_Valve_DeathMsg(p, bot_index);
}

// This message gets sent when the round is over
void BotClient_FLF_WinMessage(void *p, int bot_index)
{
   for (int i=0; i < 32; i++)
   {
      if (bots[i].is_used)  // count the number of bots in use
         bots[i].round_end = 1;
   }
}

void BotClient_Valve_SetFOV(void *p, int bot_index)
{
	bots[bot_index].fov = *(int *)p;
}

void BotClient_TFC_SetFOV(void *p, int bot_index)
{
	BotClient_Valve_SetFOV(p, bot_index);
}


void BotClient_SI_VGUIMenu(void *p, int bot_index)
{
	int num = *(int *)p;
	if (num == 2)
	{
		bots[bot_index].start_action = MSG_SI_TEAM_SELECT;
	}
	else if (num ==3)
	{
		bots[bot_index].start_action = MSG_SI_CLASS_SELECT;
	}
}

void BotClient_TFC_StatusValue(void *p, int bot_index)
{
	static int state = 0;
	static int type;
	state++;
	if (state == 1)
	{
		type = *(int *)p;
	}
	else if (state == 2)
	{
		state = 0;
		if (type == 4)
		{
			bots[bot_index].sentry_ammo = *(int *)p;
		}
		if (type == 2)
		{
			bots[bot_index].dispenser_health = *(int *)p;
		}
	}
}
