#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "waypoint.h"
#include "bot_weapons.h"

TF_BackPack * backpacks = NULL;
int num_backpacks = 0;

TF_BackPack * GetBackPack(edict_t * pEdict, bool alloc)
{
	int i;
	for (i = 0; i < num_backpacks; i++)
	{
		if (backpacks[i].pEdict == pEdict)
		{
			return &(backpacks[i]);
		}
	}
	if (!alloc) return NULL;
	//not found, so realloc the array
	TF_BackPack * new_backpacks = (TF_BackPack *)realloc(backpacks, sizeof(TF_BackPack) * (num_backpacks + 1));
	if (!new_backpacks)
	{
		return NULL;
	}
	backpacks = new_backpacks;
	backpacks[num_backpacks].cells = 0;
	backpacks[num_backpacks].shells = 0;
	backpacks[num_backpacks].rockets = 0;
	backpacks[num_backpacks].nails = 0;
	backpacks[num_backpacks].gren1 = 0;
	backpacks[num_backpacks].gren2 = 0;
	backpacks[num_backpacks].detpack = 0;
	backpacks[num_backpacks].health = 0;
	backpacks[num_backpacks].armorvalue = 0;
	backpacks[num_backpacks].pEdict = pEdict;
	num_backpacks++;
	return &(backpacks[num_backpacks-1]);
}

void RemoveBackPacks(void)
{
	free(backpacks);
	backpacks = NULL;
	num_backpacks = 0;
}
