#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"

extern int mod_id;
extern void UTIL_BuildFileName(char *filename, char *arg1, char *arg2);


float base_weapon_fitness[32];

#define TF_MAX_WEAPON_NAMES (sizeof(tf_weapon_names)/sizeof(char*))

char * tf_weapon_names[] = {
	"TF_WEAPON_UNKNOWN0",
	"TF_WEAPON_UNKNOWN1",
	"TF_WEAPON_UNKNOWN2",
	"TF_WEAPON_MEDIKIT",
	"TF_WEAPON_SPANNER",
	"TF_WEAPON_AXE",
	"TF_WEAPON_SNIPERRIFLE",
	"TF_WEAPON_AUTORIFLE",
	"TF_WEAPON_SHOTGUN",
	"TF_WEAPON_SUPERSHOTGUN",
	"TF_WEAPON_NAILGUN",
	"TF_WEAPON_SUPERNAILGUN",
	"TF_WEAPON_GL",
	"TF_WEAPON_FLAMETHROWER"
	"TF_WEAPON_RPG",
	"TF_WEAPON_IC",
	"TF_WEAPON_UNKNOWN16",
	"TF_WEAPON_AC",
	"TF_WEAPON_UNKNOWN18",
	"TF_WEAPON_UNKNOWN19",
	"TF_WEAPON_TRANQ",
	"TF_WEAPON_RAILGUN",
	"TF_WEAPON_PL",
	"TF_WEAPON_KNIFE"
};

#define FLF_MAX_WEAPON_NAMES (sizeof(flf_weapon_names)/sizeof(char*))

char * flf_weapon_names[] = {
	"FLF_WEAPON_UNKNOWN0",
	"FLF_WEAPON_UNKNOWN1",
	"FLF_WEAPON_UNKNOWN2",
	"FLF_WEAPON_UNKNOWN3",
	"FLF_WEAPON_UNKNOWN4",
	"FLF_WEAPON_UNKNOWN5",
	"FLF_WEAPON_UNKNOWN6",
	"FLF_WEAPON_UNKNOWN7",
	"FLF_WEAPON_UNKNOWN8",
	"FLF_WEAPON_SAKO", // 9 //rifle
	"FLF_WEAPON_AK5", // 10 //assault rifle
	"FLF_WEAPON_RS202M2", // 11 //shotgun, 10 rounds
	"FLF_WEAPON_UNKNOWN12",
	"FLF_WEAPON_UNKNOWN13",
	"FLF_WEAPON_UNKNOWN14",
	"FLF_WEAPON_UNKNOWN15",
	"FLF_WEAPON_MP5SD", // 16  //smg
	"FLF_WEAPON_M4", // 17  //assult rifle, zoom
	"FLF_WEAPON_FLASHBANG", // 18
	"FLF_WEAPON_HEGRENADE", // 19
	"FLF_WEAPON_MP5A2", // 20 //smg
	"FLF_WEAPON_UMP45", // 21 //smg
	"FLF_WEAPON_SPAS12", // 22 //shotgun
	"FLF_WEAPON_BERETTA", // 23 //pistol
	"FLF_WEAPON_KNIFE", // 24
	"FLF_WEAPON_MAC10", // 25 //smg
	"FLF_WEAPON_MK23", // 26 //pistol
	"FLF_WEAPON_MSG90", // 27 //rifle
	"FLF_WEAPON_FAMAS", // 28 //assault rifle
	"FLF_WEAPON_HK21" // 29 //big gun
};

bool LoadWeaponData(void)
{
	char  filename[256];
	FILE * fp;
	int max_names,i;
	char ** weapon_names;
	char name[80];
	float fitness;

	if (mod_id == TFC_DLL)
	{
		max_names = TF_MAX_WEAPON_NAMES;
		weapon_names = tf_weapon_names;
	}
	else if (mod_id == FLF_DLL)
	{
		max_names = FLF_MAX_WEAPON_NAMES;
		weapon_names = flf_weapon_names;
	}
	else
	{
		return FALSE; //no need to be here
	}

	for (i = 0; i < 32; i++)
	{
		base_weapon_fitness[i] = -1.0;
	}

	UTIL_BuildFileName(filename, "odd_weapons.txt", "");
	fp = fopen(filename, "r");
	if (!fp)
	{
		return FALSE;
	}

	while (!feof(fp))
	{
		if (fscanf(fp, "%s%f", name, &fitness)==2)
		{
			for(i = 0; i < max_names; i++)
			{
				if (stricmp(name, weapon_names[i])==0)
				{
					base_weapon_fitness[i] = fitness;
					break;
				}
			}
		}
	}
	fclose(fp);
	return TRUE;
}

float GetBaseFitnessFromFile(int weapon_id)
{
	if (weapon_id < 0 || weapon_id > 31)
	{
		return -1.0;
	}
	else
	{
		return base_weapon_fitness[weapon_id];
	}
}
		


